lmpr:          EQU  &FA
hmpr:          EQU  &FB
vmpr:          EQU  &FC
rom0_off:      EQU  %00100000
mode_4:        EQU  %01100000
base:          EQU  &8000

ROTO_WIDTH:	EQU 128
ROTO_HEIGHT:	EQU 64

LENGTH:	EQU	1344
STRENGTH:	EQU	32
CENTER:	EQU	127

BASESINE:	EQU	&8A00
ROTODIFFS:	EQU	&8B00

               ORG  base
               DUMP $

start:    DI

	IN   A,(vmpr)
	AND  %00011111
	OR   rom0_off
	OUT  (lmpr),A
;	OR   mode_4
;	OUT (vmpr),A

;	CALL gensine0

gensine0:
	EXX
	LD DE,BASESINE
	EXX

	LD HL,CENTER*256
	LD DE,-LENGTH
epi256:
	ADD HL,DE
	EX DE,HL
	ADD HL,BC
	EX DE,HL
	LD A,H
	PUSH AF

	CP CENTER
JR NC,nodown

	LD BC,STRENGTH
	LD A,(change)
	OR A
	JR NZ,nochang1
		LD DE,-LENGTH
        nochang1:
	INC A
	LD (change),A
    JR noup

    nodown:
        LD BC,-STRENGTH
        LD A,(change)
	DEC A
        JR NZ,nochang2
        LD DE,LENGTH
    nochang2:
;	XOR A
	LD (change),A
    noup:

    POP AF
    EXX
	;SRL A
	;SLL A
SUB 160

	LD (DE),A
	INC E
	EXX
    JR NZ,epi256



main_loop:

    LD HL,nframe
	LD C,(HL)
    INC (HL)

	; call provide_vectors
	; c = angle

	LD IXH,&8A
	LD IXL,C				;sin
	LD H,&8A
	LD A,C
	SUB 64
	LD L,A 		;cos

;	cos,sin
	LD E,(HL)
	LD D,0
	EX DE,HL
	LD (vec_horizontal),HL
	LD L,(IX)
;	LD H,0
	LD (vec_horizontal+2),HL

;	sin,-cos
	LD (vec_vertical),HL
	EX DE,HL
	LD B,(HL)
	XOR A
	SUB B
	LD E,A
	LD D,255
	EX DE,HL
	LD (vec_vertical+2),HL

; ----------------------

;	call calc_roto_diffs

	LD IX,ROTODIFFS
	LD HL,(vec_vertical)
	EX DE,HL
;	LD HL,0

	EXX
	LD HL,(vec_vertical+2)
	EX DE,HL
;	LD HL,128*128
	LD BC,8
	EXX

	LD C,ROTO_HEIGHT
	roto_diffs_y:
		LD (IX),L
		LD (IX+1),H
		ADD HL,DE
		EXX
		LD (IX+4),L
		LD (IX+5),H
		ADD HL,DE
		EXX

		PUSH HL
		LD HL,(vec_horizontal)
		LD (IX+2),L
		LD (IX+3),H
		LD HL,(vec_horizontal+2)
		LD (IX+6),L
		LD (IX+7),H
		POP HL

	EXX
	ADD IX,BC
	EXX

	DEC C
	JR NZ,roto_diffs_y

; ------------------------
;	CALL calc_roto

calc_roto:
	LD BC,16*256
	LD IY,ROTODIFFS

    LD IXH,ROTO_HEIGHT
	roto_y:
		LD L,(IY)
		INC IYL
		LD H,(IY)
		INC IYL
		LD E,(IY)
		INC IYL
		LD D,(IY)
		INC IY

		EXX
		LD L,(IY)
		INC IYL
		LD H,(IY)
		INC IYL
		LD E,(IY)
		INC IYL
		LD D,(IY)
		INC IY
		LD B,1
		EXX


		LD IXL,ROTO_WIDTH
		roto_x:

			ADD HL,DE
			LD A,H
			EXX
			AND H
			ADD HL,DE
			EXX

			LD (BC),A
			INC C

		DEC IXL
		JR NZ,roto_x
	INC B
	LD C,0
	DEC IXH
	JR NZ,roto_y

	JP main_loop


vec_horizontal: EQU &8200
vec_vertical: EQU &8204
nframe: EQU &8208
change: EQU &820a

